var network = {};

//--------------------------------------------------------
// Gestion du proxy
network.changeProxy = function(pHost, pPort, pType){
	// Changement de param de proxy
	var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	prefs.unlockPref("network.proxy.http");
	prefs.unlockPref("network.proxy.http_port");
	prefs.unlockPref("network.proxy.type");
	prefs.setCharPref("network.proxy.http", pHost);
	prefs.setIntPref("network.proxy.http_port", pPort);
	prefs.setIntPref("network.proxy.type", pType);
}
//--------------------------------------------------------
// Differents types de requetes
//--------------------------------------------------------
network.XMLHttpReq = function(pURL){
	try{
    	var p = new XMLHttpRequest();
    	p.onload = null;
    	p.open("GET",pURL, false);
    	p.send('');
    	if(p.status == "200" || p.status == "204")	{
    		if(p.responseXML){
	    		// Traitement de la reponse XML
	    		var vNode = p.responseXML.documentElement;
	    		return vNode;
	    	}
	    	else return true;
    	}
    	else{
    		alert("Le serveur a renvoye une erreur "+p.status);
    	}
    	return false;
	}catch(e){
		alert("Le serveur ne répond pas. Veuillez contacter l'administrateur de votre centre de consultation");
		ut.debug("XMLHttpReq : Erreur a l'execution de la requete pour l'adresse : \n"+pURL+"\nStatus de la réponse : "+p.status);
		return false;
	}
}
//--------------------------------------------------------
network.XMLHttpReqDetailed = function(pURL){
	try{
    	var p = new XMLHttpRequest();
    	p.onload = null;
    	p.open("GET",pURL, false);
    	p.send('');
    	if(p.status == "200" || p.status == "204")	{
    		if(p.responseXML){
	    		// Traitement de la reponse XML
	    		var vNode = p.responseXML;
	    		return vNode;
	    	}
	    	else return true;
    	}
    	else{
    		alert("Le serveur a renvoye une erreur "+p.status);
    	}
    	return false;
	}catch(e){
		alert("Le serveur ne répond pas. Veuillez contacter l'administrateur de votre centre de consultation");
		ut.debug("XMLHttpReqDetailed : Erreur a l'execution de la requete pour l'adresse : \n"+pURL+"\nStatus de la réponse : "+p.status);
		return false;
	}
}
//--------------------------------------------------------
network.textHttpReq = function(pURL){
	try{
    	var p = new XMLHttpRequest();
    	p.onload = null;
    	p.open("GET",pURL, false);
    	p.send('');
    	if(p.status == "200" || p.status == "204")	{
    		if(p.responseText){
	    		// Traitement de la reponse XML
	    		var vNode = p.responseText;
	    		return vNode;
	    	}
	    	else return true;
    	}
    	else{
    		alert("Le serveur a renvoye une erreur "+p.status);
    	}
    	return false;
	}catch(e){
		alert("Le serveur ne répond pas. Veuillez contacter l'administrateur de votre centre de consultation");
		ut.debug("textHttpReq : Erreur a l'execution de la requete pour l'adresse : \n"+pURL+"\nStatus de la réponse : "+p.status);
		return false;
	}
}

//--------------------------------------------------------
// Appel de procedure distante
// APPEL synchrone
network.RPCCall = function(pHarbor, pMethod, pParams){
	try{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch(e) {
		alert(e);
		return false;
	}
	var vSoapCall = new SOAPCall();
	vSoapCall.transportURI = pHarbor;
	vSoapCall.encode(0, pMethod, "harbor", 0, null, pParams.length, pParams);

	// APPEL synchrone
	var vSoapResponse = vSoapCall.invoke();
	var num = new Object();
	var vResult = vSoapResponse.getParameters(false,num);
	if(vResult[0]) {
		return vResult[0].value;
	}
	else return null;
}

//--------------------------------------------------------
// APPEL Asynchrone
network.AsyncRPCCall = function(pHarbor, pMethod, pParams, pCallback){
	try{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var vSoapCall = new SOAPCall();
		vSoapCall.transportURI = pHarbor;
		vSoapCall.encode(0, pMethod, "harbor", 0, null, pParams.length, pParams);
		
		vSoapCall.asyncInvoke(
			function(response,call,status, last){
				try{
					if(response == null){
						pCallback(null);
					}
					else if (status != 0){ 
						alert("Le service est indisponible");
						return false;
					} else {
						var vFault = response.fault;
						if (vFault != null) { 
							var vCode = vFault.faultCode; 
							var vMsg = vFault.faultString; 
							alert("Erreur SOAP :\n\n" + "Code: "  + vCode + "\n\nMessage: " + vMsg);
							return false;
						} else {
							 // Si tout se passe bien
//							alert(ut.getXml(response.body));
							var num = new Object();
							var vResult = response.getParameters(false,num);
							if(vResult[0]) {
								pCallback(vResult[0].value);
								return true;
							}
						 }
					}
					return false;
				}catch(e){alert(e); return false;}
			}
		);
		return true;
	} catch(e) {
		alert(e);
		return false;
	}
}
