const XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const HTMLNS = "http://www.w3.org/1999/xhtml";
const SVGNS = "http://www.w3.org/2000/svg";
const DLWEBNS = "http://dlweb.ina.fr/";

const _DEBUG = 0;

var ut = {};
//--------------------------------------------------------
ut.openExternalBrowser = function(pURL){
	try{
//		this.debug("avant : "+pURL);
		var reg = new RegExp("^http:","g");
		if(!reg.test(pURL)) pURL = "http://"+pURL;
//		this.debug("apr?s : "+pURL);
		
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var extps = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
		if (extps.externalProtocolHandlerExists("http")) {
			// Handler for http:// URLs exists
			// first construct an nsIURI object using the ioservice
			var ioservice = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var uriToOpen = ioservice.newURI(pURL, null, null);
			// now, open it!
			extps.loadURI(uriToOpen, null);
		}
	}catch(e){ut.debug(e)}
}
//--------------------------------------------------------
ut.showConsole = function() {
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var vWin = window.open("chrome://global/content/console.xul", "_blank","chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
	return vWin;
}
//--------------------------------------------------------
/* Affiche un texte dans la console. */
ut.debug = function(pText) {
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage(pText);
}
//--------------------------------------------------------
/* Serialize un Element Dom. */
ut.getXml = function(pElement){
	return pElement ? new XMLSerializer().serializeToString(pElement) : "";
}
//--------------------------------------------------------
ut.getXmlElt = function(pElement){
	if( ! pElement || pElement.nodeType != 1) return "<notElt:"+pElement+">";
	var vS = "<"+pElement.nodeName;
	var vAtts = pElement.attributes;
	for (var i = 0; i < vAtts.length; i++) {
		var vAtt = vAtts.item(i);
		vS += " "+vAtt.nodeName+"=\""+vAtt.nodeValue+"\"";
	}
	return vS+( (pElement.firstChild)? ">...</>" : "/>");
}
//--------------------------------------------------------
ut.getArrayXmlElt = function(pArray){
	if(!pArray) return "NULL";
	var vS = "[\n";
	for (var i = 0; i < pArray.length; i++) {
		vS += ut.getXmlElt(pArray[i])+"\n";
	}
	return vS+"]";
}
//--------------------------------------------------------
/* Liste les proprits d'un objet et les renvoie dans la console. */
ut.listProperties = function(pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'[' + pObj[vProp]+ ']'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}
//--------------------------------------------------------
function serializeDomToFile(pDomTree, pFilePath){
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}
	var serializer = new XMLSerializer();

	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(pFilePath);
	if (file.exists() == false) {
		ut.debug( "Creating file... " );
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}

	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	foStream.init(file, 0x04 | 0x08 | 0x20, 0664, 0);   // write, create, truncate
	serializer.serializeToStream(pDomTree, foStream, "");
	foStream.close();
}
//--------------------------------------------------------
ut.genGUI = function(){
	function S4() {return (((1+Math.random())*0x10000)|0).toString(16).substring(1);}
	var guid = (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4()).toUpperCase();
	return guid;
}
//--------------------------------------------------------
ut.stringToDate = function(pDateStr){
	var vDate = new Date();
	// Format "YYYY-MM-DD HH:MM:SS"
	if(pDateStr.length == 19){
		vDate.setFullYear(pDateStr.substr(0,4));
		vDate.setMonth((parseInt(pDateStr.substr(5,2))-1));
		vDate.setDate(pDateStr.substr(8,2));
		vDate.setHours(pDateStr.substr(11,2));
		vDate.setMinutes(pDateStr.substr(14,2));
		vDate.setSeconds(pDateStr.substr(17,2));
		vDate.setMilliseconds(0);
	}
	return vDate;	
}


//--------------------------------------------------------
ut.dateToString = function(pDateObj){
	var vString;
	var mo = (pDateObj.getMonth()+1);
	if (mo < 10) { mo = "0"+mo }
	var d = pDateObj.getDate();
	if(d < 10) {d = "0"+d};
	var h = pDateObj.getHours();
	if (h < 10) {h = "0" + h}
	var m = pDateObj.getMinutes();
	if (m < 10) {m = "0" + m}
	var s = pDateObj.getSeconds();
	if (s < 10) {s = "0" + s}
	vString = pDateObj.getFullYear()+"-"+mo+"-"+d+" "+h+":"+m+":"+s;

//	this.debug("dateToString : "+vString);
	return vString;	
}

